/* $Id$

This file is part of libmspgl
Copyright © 2007 Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_GL_PROGRAM_H_
#define MSP_GL_PROGRAM_H_

#include <list>
#include <string>
#include <GL/gl.h>
#include "shader.h"
#include "types.h"

namespace Msp {
namespace GL {

class Shader;

class Program
{
public:
	Program();
	virtual ~Program();

	void attach_shader(Shader &shader);
	void detach_shader(Shader &shader);
	void bind_attribute(int, const std::string &);
	bool link();
	int get_param(GLenum param) const;
	std::string get_info_log() const;
	void bind();

	static void unbind();
private:
	uint id;
	std::list<Shader *> shaders;
	bool linked;

	static Program *cur_prog;
};

} // namespace GL
} // namespace Msp

#endif
