/* $Id$

This file is part of libmspgl
Copyright © 2007 Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#include "simpleprogram.h"

using namespace std;

namespace Msp {
namespace GL {

SimpleProgram::SimpleProgram(const string &vert_src, const string &frag_src):
	vert_shader(VERTEX_SHADER),
	frag_shader(FRAGMENT_SHADER)
{
	vert_shader.source(vert_src);
	frag_shader.source(frag_src);
	attach_shader(vert_shader);
	attach_shader(frag_shader);
	link();
}

SimpleProgram::~SimpleProgram()
{
	detach_shader(vert_shader);
	detach_shader(frag_shader);
}

} // namespace GL
} // namespace Msp
